#!/usr/bin/env node
import { CUSTOM_TEMPLATE_NAME as $ } from "./utils/const.mjs";
import { projectNameForm as h, getRemoveDirForm as y, getTemplateForm as N, getTemplateChoices as T, saveGitHistoryForm as G } from "./utils/question.mjs";
import r from "prompts";
import { execSync as g } from "node:child_process";
import { existsSync as p, rmSync as l } from "node:fs";
import f, { resolve as j } from "node:path";
import t from "chalk";
import { getConfigPath as x, batchHandler as R } from "@done-coding/cli-template";
import { lookForParentTarget as C } from "@done-coding/node-tools";
const k = async (u) => {
  const { projectName: d, template: v } = u, o = ((d ?? (await r(h)).projectName) || "").trim();
  if (!o.trim()) {
    console.log(t.red("项目名称不能为空"));
    return;
  }
  if (o.includes(" ") || o.includes("\\") || o.includes("/")) {
    console.log(t.red("项目名称不能包含空格或者\\或者/"));
    return;
  }
  const i = j(process.cwd(), o);
  if (p(i)) {
    const { isRemove: e } = await r(y());
    if (e === !0)
      l(i, { recursive: !0, force: !0 });
    else
      return console.log(t.red("项目已存在")), process.exit(1);
  }
  const n = v ?? (await r(await N())).template;
  let c = "";
  if (n === $) {
    const { customUrl: e } = await r({
      type: "text",
      name: "customUrl",
      message: "请输入自定义模板路径"
    });
    c = e;
  } else {
    const e = (await T()).find(
      (s) => s.name === n
    );
    if (!e)
      return console.log(t.red(`模板${n}不存在`)), process.exit(1);
    if (!e.url)
      return console.log(t.red(`模板${n}仓库地址不存在`)), process.exit(1);
    c = e.url;
  }
  const m = C(".git");
  console.log(t.green("正在初始化项目，请稍等...")), g(`git clone ${c} ${o} --depth=1`);
  const a = x(i);
  if (a) {
    await R({
      rootDir: i
    });
    const { isRemoveTemplateConfig: e } = await r({
      type: "confirm",
      name: "isRemoveTemplateConfig",
      message: `已成功将模板项目配置注入到当前项目，是否删除模板项目配置文件(${a})`
    });
    e && l(a, { force: !0 });
  }
  if (console.log(t.green("项目初始化完成")), m) {
    const e = f.resolve(i), s = f.resolve(e, ".git");
    if (!p(s))
      throw new Error("git目录不存在");
    const { isRemoveGit: w } = await r({
      type: "confirm",
      name: "isRemoveGit",
      message: `项目创建在父级git仓库${m}中，是否删除${o}目录下的.git(${s})`
    });
    w ? (l(s, { recursive: !0, force: !0 }), console.log(t.green("已删除当前项目git目录"))) : console.log(
      t.yellow(
        `项目创建在父级git仓库${m}中，请手动删除${o}目录下的.git(${s})，否则会影响后续的git操作`
      )
    );
  } else
    (await r(G)).saveGitHistory && (g(
      `cd ${i} && git remote rename origin upstream && git fetch --unshallow`
    ), console.log(
      t.green(
        "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
      )
    ), console.log(
      t.green("已保存git历史记录，后续可以与模板git仓库有完整的交互")
    ));
  console.log(
    t.blue(`
使用步骤: 
  1. cd ${o}
  2. pnpm install
  3. pnpm run dev
  `)
  );
};
export {
  k as handler
};
